﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Drawing;
using System.ComponentModel;

namespace EditorTestbed
{
    [Serializable]
    public class Entity
    {
        public Entity()
        {
            m_name = "Entity_" + s_id.ToString();
            m_id = s_id++;
            m_vitalityPoints = 0;
            m_position.x = 0.0f;
            m_position.y = 0.0f;
            m_position.z = 0.0f;
            m_color = Color.Red;
        }
        static uint s_id = 0;
        public uint m_id;
        string m_name;
        int m_vitalityPoints;
        public Vector3 m_position;
        Color m_color;
        public ObjectType m_objectType;

        [CategoryAttribute("Global")]
        public string Name
        {
            get { return m_name; }
            set { m_name = value; }
        }
        [CategoryAttribute("Global")]
        public int VitalityPoints
        {
            get { return m_vitalityPoints; }
            set 
            { 
                m_vitalityPoints = value;
                Testbed.ms_instance.SendObjectProperties(this);
            }
        }
        [CategoryAttribute("Mesh")]
        public Color MeshColor
        {
            get { return m_color; }
            set 
            { 
                m_color = value;
                Testbed.ms_instance.SendObjectProperties(this);
            }
        }
    }
}
