﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using WeifenLuo.WinFormsUI.Docking;

namespace EditorTestbed
{
    public partial class RenderArea : DockContent
    {
        public RenderArea()
        {
            InitializeComponent();
        }

        public IntPtr GetRenderHWND()
        {
            return renderPanel.Handle;
        }
        public int GetRenderWidth()
        {
            return renderPanel.Width;
        }
        public int GetRenderHeight()
        {
            return renderPanel.Height;
        }

        private void renderPanel_MouseDown(object sender, MouseEventArgs e)
        {
            MouseButton button = MouseButton.MIDDLE;
            if (e.Button == MouseButtons.Left)
                button = MouseButton.LEFT;
            else if (e.Button == MouseButtons.Right)
                button = MouseButton.RIGHT;
            Testbed.ms_instance.OnMouseEvent(button, MessageID.MOUSE_DOWN);
        }

        private void renderPanel_MouseMove(object sender, MouseEventArgs e)
        {
            Testbed.ms_instance.OnMouseMoveEvent(e.X, e.Y);
        }

        private void RenderArea_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Delete)
                Testbed.ms_instance.OnObjectDelete();
            else
                Testbed.ms_instance.OnKeyboardEvent(e.KeyCode, MessageID.KEY_DOWN);
        }

        private void renderPanel_MouseUp(object sender, MouseEventArgs e)
        {
            MouseButton button = MouseButton.MIDDLE;
            if (e.Button == MouseButtons.Left)
                button = MouseButton.LEFT;
            else if (e.Button == MouseButtons.Right)
                button = MouseButton.RIGHT;
            Testbed.ms_instance.OnMouseEvent(button, MessageID.MOUSE_UP);
        }

        private void renderPanel_Resize(object sender, EventArgs e)
        {
            Testbed.ms_instance.OnViewportResize(renderPanel.Width, renderPanel.Height);
        }
    }
}
