﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;


namespace EditorTestbed
{
    public class World
    {
        public void AddEntity(Entity ent)
        {
            m_entities.Add(ent);
        }
        public Entity FindEntity(uint id)
        {
            // @facepalm... Just to make it work quickly.
            foreach (Entity ent in m_entities)
            {
                if (ent.m_id == id)
                    return ent;
            }
            return null;
        }
        public void RemoveEntity(Entity ent)
        {
            m_entities.Remove(ent);
        }
        public List<Entity> Entities
        {
            get { return m_entities; }
        }

        public void Save(string fileName)
        {
            Stream s = File.Open(fileName, FileMode.Create);
            BinaryFormatter formatter = new BinaryFormatter();
            formatter.Serialize(s, m_entities);    
            s.Close();
        }
        public void Load(string fileName)
        {
            Stream s = File.Open(fileName, FileMode.Open);
            BinaryFormatter formatter = new BinaryFormatter();
            m_entities = (List<Entity>)formatter.Deserialize(s);
            s.Close();
        }
        public uint GetNextID()
        {
            uint ret = 0;
            foreach (Entity e in m_entities)
            {
                if (e.m_id > ret)
                    ret = e.m_id;
            }
            return ret + 1;
        }

        List<Entity> m_entities = new List<Entity>();
    }
}
