#include "ipc/Message.h"
#include <new>	// for placement new

namespace rde
{
Message* Message::Create(uint32_t id, int32_t transaction, uint32_t size, 
						 uint32_t type)
{
	// "Trick" to avoid 2 mem allocations instead of one.
	// We basically glue message data to message itself. m_data array
	// has to be at the very end of the Message class.
	void* mem = operator new(sizeof(Message) + size);
	Message* msg = new(mem) Message(id, transaction, size, type);
	return msg;
}

Message::Message(uint32_t id, int32_t transaction, uint32_t size, uint32_t type)
:	m_next(0)
{
	m_header.id = id;
	m_header.transaction = transaction;
	m_header.size = size;
	m_header.type = type;
}

Message::~Message()
{
}

}
