#pragma once
#ifndef IPC_MESSAGE_H
#define IPC_MESSAGE_H

#include "core/Config.h"

namespace rde
{
namespace MessageType
{
	enum Enum
	{
		USER,
		PROTOCOL
	};
}

// @todo	Provide pool for messages.
class Message
{
	friend class MessageQueue;
public:
	struct Header
	{
		uint32_t	id;
		int32_t		transaction;
		uint32_t	size;
		uint32_t	type;
	};

	static Message* Create(uint32_t id, int32_t transaction, uint32_t size, 
		uint32_t type = MessageType::USER);
	~Message();

	const Header& GetHeader() const	{ return m_header; }
	void* GetData() 					{ return &m_data[0]; }
	const void* GetData() const		{ return &m_data[0]; }

private:	
	Message(uint32_t id, int32_t transaction, uint32_t size, uint32_t type = MessageType::USER);
	Message(const Message&);
	Message& operator=(const Message&);

	Header		m_header;
	Message*	m_next;
	uint8_t		m_data[1];
};
}

#endif
