#pragma once
#ifndef IPC_MESSAGE_QUEUE_H
#define IPC_MESSAGE_QUEUE_H

#include "core/Mutex.h"
#include "core/ThreadEvent.h"

namespace rde
{
class Message;

class MessageQueue
{
public:
	MessageQueue();

	void Enqueue(Message* m);
	Message* Dequeue();
	void Clear();

	// Waits for item to appear in the queue.
	// With multiple threads waiting, it's not guaranteed
	// we'll be able to get it when we wake up!
	void WaitForItem();
	void Signal();

private:
	Message*		m_head;
	Message*		m_tail;
	volatile int	m_numItems;
	Mutex			m_mutex;
	ThreadEvent		m_enqueueEvent;
};
}

#endif
