#pragma once
#ifndef IPC_PIPE_H
#define IPC_PIPE_H

#include "core/System.h"

//#define RDE_IPC_DEBUG_LEVEL	5

namespace rde
{
class ThreadEvent;
class Pipe
{
public:
	static const uint32_t	kBufferSize = 8192;

	Pipe();
	~Pipe();

	bool Create(const char* name);
	bool Open(const char* name);
	bool Connect(const ThreadEvent& evtTerminate);
	bool Read(void* buffer, uint32_t bytes, const ThreadEvent& evtTerminate, 
		uint32_t& bytesRead);
	bool Write(const void* buffer, uint32_t bytes, const ThreadEvent& evtTerminate, 
		uint32_t& bytesWritten);
	// @note	Will disconnect if needed.
	void Close();
	void Disconnect();

private:
	Pipe(const Pipe&);
	Pipe& operator=(const Pipe&);

	struct Impl;
	Impl*	m_impl;
};
}

#endif
