float4x4 WorldMatrix;
float4x4 ModelViewProjection;
float4  DiffuseColor = {0, 1, 0, 1};
float3	LightPos = { 10, 500, -1000 };
int	    CullingMode = 1;
int     FillingMode = 3;

struct VS_OUTPUT
{
    float4  position	: POSITION;
    float4  diffuse	: COLOR0;
};

VS_OUTPUT VsMain(float3 pos : POSITION, float3 n : NORMAL)
{
    VS_OUTPUT vout;
    
    float3 wpos = mul(pos, WorldMatrix);
    float3 lvec = normalize(LightPos - wpos);

    vout.position = mul(float4(pos, 1), ModelViewProjection);
    vout.diffuse = dot(lvec, n) * DiffuseColor;

    return vout;
}

technique t0
{
    pass p0
    {
        VertexShader = compile vs_1_1 VsMain();
        ColorWriteEnable = Red | Green | Blue | Alpha;
        FillMode = (FillingMode);
        CullMode = (CullingMode);
        ColorOp[0] = SelectArg1;
        ColorArg1[0] = Diffuse;
        //ColorArg2[0] = Diffuse;
        //Texture[0] = (DecalTexture);
        AlphaOp[0] = Disable;
        ColorOp[1] = Disable;
        AlphaOp[1] = Disable;
    }
}
