
float4x4 ModelViewProjection;
float4      DiffuseColor = {1, 1, 1, 1};
int	    CullingMode = 1;

struct VS_OUTPUT
{
    float4  position	: POSITION;
    float4  diffuse	: COLOR0;
};

VS_OUTPUT VsMain(float3 pos : POSITION)
{
    VS_OUTPUT vout;

    vout.position = mul(float4(pos, 1), ModelViewProjection);
    vout.diffuse = DiffuseColor;

    return vout;
}

technique t0
{
    pass p0
    {
        VertexShader = compile vs_1_1 VsMain();
        ColorWriteEnable = Red | Green | Blue | Alpha;
        FillMode = 2;
	      CullMode = (CullingMode);
        ColorOp[0] = SelectArg1;
        ColorArg1[0] = Diffuse;
        //ColorArg2[0] = Diffuse;
        AlphaOp[0] = Disable;
    	ColorOp[1] = Disable;
    	AlphaOp[1] = Disable;
    }
}
