#pragma once

#include "core/win32/Windows.h"
#include "ComPtr.h"

class Mesh;
class Scene;
class Application
{
public:
	Application();
	~Application();

	bool Init(HWND hWindow, int width, int height);
	void Frame(float, Scene&, Mesh*);

	Mesh* CreateCube(float width, float height, float depth);
	Mesh* CreateSphere(float radius);
	Mesh* CreateTorus(float innerRadius, float outerRadius);
	rde::ComPtr<ID3DXEffect> CreateEffect(const char* fxName);

private:
	struct Impl;
	Impl*	m_impl;
};