#pragma once

#include "Node.h"

class Camera : public Node
{
public:
	struct Viewport
	{
		Viewport();
		Viewport(int x_, int y_, int w, int h);

		int	x, y;
		int width, height;
	};

	Camera();
	void Setup(float nearPlaneDist, float farPlaneDist, float horzFov);

	void SetViewport(int x, int y, int width, int height);
	void UpdateTransforms();

	const D3DXMATRIX& GetViewProjection() const	{ return m_viewProjection; }
	const D3DXMATRIX& GetProjection() const		{ return m_projection; }
	const D3DXMATRIX& GetView() const				{ return m_view; }
	const Viewport& GetViewport() const			{ return m_viewport; }

private:
	float				m_horizontalFov;
	float				m_nearPlaneDist;
	float				m_farPlaneDist;
	float				m_aspect;
	Viewport			m_viewport;
	mutable bool		m_projectionDirty;
	mutable D3DXMATRIX	m_view;
	mutable D3DXMATRIX	m_projection;
	mutable D3DXMATRIX	m_viewProjection;
};

