#include "PreCompiled.h"
#include "Entity.h"
#include "Mesh.h"
#include "core/RdeAssert.h"

static rde::uint32_t s_id(0);
Entity::Entity(rde::uint32_t id)
:	m_id(id == kInvalidID ? s_id++ : id),
	m_mesh(0),
	m_vitalityPoints(0)
{
}

Entity::~Entity()
{
	delete m_mesh;
}

void Entity::SetVitalityPoints(int vp)
{
	m_vitalityPoints = vp;
}
int Entity::GetVitalityPoints() const
{
	return m_vitalityPoints;
}

void Entity::SetMesh(Mesh* m)
{
	RDE_ASSERT(m_mesh == 0);
	m_mesh = m;
	if (m_mesh)
		m_mesh->m_parent = this;
}

void Entity::SetNextID(rde::uint32_t id)
{
	s_id = id;
}

void Entity::OnWorldTransformChange(const D3DXMATRIX& m) const
{
	if (m_mesh)
		m_mesh->m_worldTransform = m;
}

