#pragma once

#include "ComPtr.h"
#include "Node.h"
#include "core/Config.h"

class Mesh;
class Entity : public Node
{
public:
	static const rde::uint32_t kInvalidID = 0xFFFFFFFF;

	explicit Entity(rde::uint32_t id);
	~Entity();

	void SetVitalityPoints(int vp);
	int GetVitalityPoints() const;

	void SetMesh(Mesh*);
	static void SetNextID(rde::uint32_t id);

	virtual void OnWorldTransformChange(const D3DXMATRIX&) const;

	rde::uint32_t	m_id;
	Mesh*			m_mesh;
	int				m_vitalityPoints;
};
