#include "PreCompiled.h"
#include "Mesh.h"
#include "Application.h"

Mesh::Mesh()
:	m_color(1.f, 1.f, 1.f, 1.f),
	m_parent(0),
	m_boundingBox(0)
{
	::D3DXMatrixIdentity(&m_worldTransform);
}

Mesh::~Mesh()
{
	delete m_boundingBox;
}

void Mesh::PreRender(ID3DXEffect* effect)
{
	effect->SetVector("DiffuseColor", &m_color);
}
void Mesh::Render()
{
	m_mesh->DrawSubset(0);
}

void Mesh::ComputeBoundingBox(Application* app)
{
	D3DXVECTOR3* verts(0);
	m_mesh->LockVertexBuffer(D3DLOCK_READONLY, (void**)&verts);
	D3DXVECTOR3 boxMin, boxMax;
	::D3DXComputeBoundingBox(verts, m_mesh->GetNumVertices(), m_mesh->GetNumBytesPerVertex(),
		&boxMin, &boxMax);
	m_mesh->UnlockVertexBuffer();

	boxMax *= 1.05f;
	D3DXVECTOR3 extents = boxMax - boxMin;
	m_boundingBox = app->CreateCube(extents.x, extents.y, extents.z);
}
