#pragma once

#include "ComPtr.h"

class Entity;
class Mesh
{
	friend class Application;

public:
	~Mesh();

	void PreRender(ID3DXEffect*);
	void Render();

	void ComputeBoundingBox(Application*);

	D3DXMATRIX				m_worldTransform;
	D3DXVECTOR4				m_color;
	Entity*					m_parent;
	ID3DXMesh* GetMesh() const { return m_mesh.Get(); }
private:
	Mesh();

	rde::ComPtr<ID3DXMesh>	m_mesh;
	Mesh*					m_boundingBox;
};

