#pragma once

class Node
{
public:
	Node();
	virtual ~Node() {}

	virtual void Update();

	void SetPosition(const D3DXVECTOR3& pos);
	const D3DXVECTOR3& GetPosition() const { return m_position; }

	const D3DXMATRIX& GetWorldTransform() const;
	void UpdateWorldTransform() const;

protected:
	virtual void OnWorldTransformChange(const D3DXMATRIX&) const {}

private:
	D3DXVECTOR3				m_position;
	D3DXQUATERNION			m_rotation;
	mutable D3DXMATRIX		m_worldTransform;
	mutable bool			m_isWorldTransformDirty;
};

