#pragma once

#include "Camera.h"
#include "ComPtr.h"
#include "rdestl/hash_map.h"
#include "rdestl/vector.h"

class Entity;
class Mesh;
class Scene
{
public:
	typedef rde::vector<Mesh*>	Meshes;
	typedef rde::hash_map<rde::uint32_t, Entity*>	Entities;

	explicit Scene(const rde::ComPtr<ID3DXEffect>& effect,
		const rde::ComPtr<ID3DXEffect>& wireEffect);
	~Scene();

	void AddEntity(Entity*);
	void Render();
	Entity* FindEntity(rde::uint32_t id);
	void RemoveEntity(Entity*);
	void Clear();

	Mesh* Pick(int sx, int sy);

	void RenderSelected(Mesh* selectedMesh);
	void AddMesh(Mesh*);

	Camera						m_camera;
	Meshes						m_meshes;
	Entities					m_entities;
	rde::ComPtr<ID3DXEffect>	m_effect;
	rde::ComPtr<ID3DXEffect>	m_wireEffect;
};
